#include "memcheck.h"

struct heapinfo MemCheck::hi;

int MemCheck::mark()
	{
	clear();

	if( heapcheck() < 0 )
		return 0;
	hi.ptr = 0;
	while( heapwalk(&hi) == _HEAPOK )
		if( hi.in_use )	count++;

	if( count == 0 )
		return 1;

	items = new void * [count];
	count = 0;
	if( items == 0 )
		return 0;

	hi.ptr = 0;
	while( heapwalk(&hi) == _HEAPOK )
		if( hi.in_use && hi.ptr != items )
			items[count++] = hi.ptr;
	return 1;
	}

int MemCheck::release()
	{
	void **aItems;
	int cnt;

	if( heapcheck() < 0 )
		return 0;
	cnt = 0;
	hi.ptr = 0;
	while( heapwalk(&hi) == _HEAPOK )
		if( hi.in_use && !isItem(hi.ptr) && hi.ptr != items )
			cnt++;

	if( cnt == 0 )
		aItems = 0;
	else
		{
		aItems = new void * [cnt];
		if( aItems == 0 )
			return 0;
		hi.ptr = 0;
		cnt = 0;
		while( heapwalk(&hi) == _HEAPOK )
			if( hi.in_use && !isItem(hi.ptr) && hi.ptr != items && hi.ptr != aItems )
				aItems[cnt++] = hi.ptr;
		}
	delete items;
	items = aItems;
	count = cnt;
	return 1;
	}

void MemCheck::forEach( mcAppFunc fn, void *arg )
	{
	int n;
	for( n = 0; n < count; n++ )
		fn(items[n],arg);
	}

int MemCheck::isItem( void *item )
	{
	int n;
	for( n = 0; n < count; n++ )
		if( items[n] == item )
			return 1;
	return 0;
	}
